#include <descriptor/descriptor.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define ANG_RAGGIO	30

int main(void)
{
	// ruote
	ITEM ruota, asse, raggio, r_anello;
	ITEM lista_raggi, lista_ruota, lista_ruota2;
	ITEM base, piano, r_blocco;
	ITEM piano_ant, asse_orizz, base_ant;
	ITEM lista_parte_inferiore;
	ITEM ruota_piccola, ruota_piccola2, asta, asta_tmp;
	ITEM connettore, connettore_tmp, supporto;

	// retro
	ITEM montante, piolo;
	ITEM lista_pioli, lista_scaletta;
	ITEM retro_ant, tetto, caldaia, coda;
	ITEM retro_v1, retro_v2, retro_v3, retro_v4, retro_o1, retro_o2, retro_inf, retro_inf2;
	ITEM lista_retro, lista_lato_retro;

	// parte centrale
	ITEM centrale2, centrale3;
	ITEM sostegno_tubo, cilindro_tubo, tubo;
	ITEM lista_tubi;

	// parte superiore
	ITEM sostegno, campana, superiore1, superiore2;

	// comignolo
	ITEM comignolo, cilindro_ant, anello;
	ITEM anteriore, valvola, v_mozzo, v_raggio;
	ITEM lista_raggi_v, lista_anteriore;

	// lanterna
	ITEM lampada, sostegno_lanterna;
	ITEM base_lanterna1, base_lanterna2, base_lanterna3, base_lanterna4;
	ITEM lista_lanterna;

	// componenti vari
	ITEM lato_scaletta, scalino, piano_scala, fondo_scala;
	ITEM lista_scala;
	ITEM blocco1, blocco2, blocco3, blocco4, componente;
	ITEM lista_blocco_oro;

	// texture e fondali
	ITEM terreno, sfondo, sfondo2, sfondo3;

	// altro
	ITEM sfera, sfera2, sfera3, sfera4, sfera5, sfera6;
	ITEM asse_r, mont_r, spigolo_r, spigolo_r2, tmp_mont;
	ITEM lista_resp;

	// materiali
	ITEM rosso, oro, nero, vetro;

	ITEM scena;
	int i;
	char nome[10];

	memset(nome, 0, 10);

	// luci e sfondo
	set_background(0.0, 0.0, 0.0, TRUE);
	set_ambient_light(1.0, 1.0, 1.0, 0.9);
	create_point_light(10.0, -2.0, 12.0, 1.0, 1.0, 1.0, 1.0, 20.0, "point_light");
	create_point_light(0.0, -10.0, 12.0, 1.0, 1.0, 1.0, 1.0, 20.0, "point_light");
	create_point_light(-10.0, 5.0, 11.0, 1.0, 1.0, 1.0, 1.0, 20.0, "point_light");
	create_point_light(8.0, 9.0, 15.0, 1.0, 1.0, 1.0, 1.0, 20.0, "point_light");

	// materiali
	rosso = create_attribute("rosso");
	set_color(rosso, 1.0, 0.0, 0.0, 0.65, 0.65);
	oro = create_attribute("oro");
	set_color(oro, 0.8, 0.8, 0.0, 0.5, 0.5);
	set_reflectivity(oro, 0.8, 0.5);
	nero = create_attribute("nero");
	set_color(nero, 0.2, 0.2, 0.2, 0.85, 0.85);
	vetro = create_attribute("vetro");
	set_color(vetro, 0.3, 0.3, 0.5, 0.9, 0.9);
	set_reflectivity(vetro, 0.5, 0.5);
	set_transparency(vetro, 0.8, 0.5, 1.0, 1.89);

	// corpo centrale
	centrale2 = read_nurbs("centrale2.db");
	set_attribute(centrale2, rosso);
	centrale3 = read_nurbs("centrale3.db");
	set_attribute(centrale3, nero);
	sostegno_tubo = read_nurbs("sostegno_tubo.db");
	tubo = read_nurbs("tubo.db");
	cilindro_tubo = read_nurbs("cilindro_tubo.db");
	// lista tubi
	set_scale(sostegno_tubo, 0.9, 0.9, 0.9);
	set_x_rotate(sostegno_tubo, -65, 1);
	set_translate(sostegno_tubo, 2.5, 1.1, 0.49);
	lista_tubi = create_list(create_copy(sostegno_tubo, "sostegno_ant_sx"), "tubo_dx");
	lista_tubi = insert_in_list(lista_tubi, tubo);
	lista_tubi = insert_in_list(lista_tubi, cilindro_tubo);
	set_translate(sostegno_tubo, -1.25, 0.0, 0.0);
	lista_tubi = insert_in_list(lista_tubi, create_copy(sostegno_tubo, "sostegno_post_sx"));
	set_attribute(lista_tubi, oro);

	// parte superiore
	sostegno = read_nurbs("sostegno_campana.db");
	set_attribute(sostegno, nero);
	campana = read_nurbs("campana.db");
	set_attribute(campana, oro);
	superiore1 = read_nurbs("superiore1.db");
	set_attribute(superiore1, oro);
	superiore2 = read_nurbs("superiore2.db");
	set_attribute(superiore2, oro);

	// comignolo
	comignolo = read_nurbs("comignolo.db");
	set_attribute(comignolo, nero);
	cilindro_ant = read_nurbs("cilindro_ant.db");
	set_attribute(cilindro_ant, nero);
	anello = read_nurbs("anello_comignolo.db");
	set_attribute(anello, oro);

	// parte anteriore
	anteriore = read_nurbs("anteriore.db");
	set_attribute(anteriore, nero);
	valvola = read_nurbs("valvola.db");
	set_attribute(valvola, oro);
	v_mozzo = read_nurbs("valvola_mozzo.db");
	set_attribute(v_mozzo, oro);
	v_raggio = read_nurbs("valvola_raggio.db");
	set_attribute(v_raggio, oro);
	// lista raggi valvola
	set_z_rotate(v_raggio, 15, 1);
	lista_raggi_v = create_list(create_copy(v_raggio, "v_raggio1"), "lista_raggi_valvola");
	for (i = 2; i <= 4; i++)
	{
		snprintf(nome, 10, "v_raggio%d", i);
		set_z_rotate(v_raggio, 90, 1);
		lista_raggi_v = insert_in_list(lista_raggi_v, create_copy(v_raggio, nome));
	}
	// lista parte anteriore
	lista_anteriore = create_list(anteriore, "lista_parte_anteriore");
	lista_anteriore = insert_in_list(lista_anteriore, valvola);
	lista_anteriore = insert_in_list(lista_anteriore, v_mozzo);
	lista_anteriore = insert_in_list(lista_anteriore, lista_raggi_v);

	// oggetti ruota
	ruota = read_nurbs("ruota.db");
	asse = read_nurbs("asse.db");
	raggio = read_nurbs("raggio_ruota.db");
	r_anello = read_nurbs("anello_ruota.db");
	// lista raggi
	lista_raggi = create_list(create_copy(raggio, "raggio1"), "lista_raggi");
	for (i = 2; i <= (360/ANG_RAGGIO); i++)
	{
		snprintf(nome, 9, "raggio%d", i);
		set_z_rotate(raggio, ANG_RAGGIO, 1);
		lista_raggi = insert_in_list(lista_raggi, create_copy(raggio, nome));
	}
	// lista ruota singola
	lista_ruota = create_list(create_copy(lista_raggi, "raggi"), "ruota");
	lista_ruota = insert_in_list(lista_ruota, create_copy(ruota, "esterno"));
	lista_ruota = insert_in_list(lista_ruota, create_copy(asse, "asse"));
	set_attribute(lista_ruota, rosso);
	set_translate(r_anello, 0.0, 0.0, 0.015);
	set_attribute(r_anello, oro);
	lista_ruota = insert_in_list(lista_ruota, create_copy(r_anello, "r_anello"));
	lista_ruota2 = create_copy(lista_ruota, "ruota2");

	// parte inferiore
	// oggetti vari
	base = read_nurbs("base.db");
	piano = read_nurbs("piano.db");
	r_blocco = read_nurbs("blocco_superiore.db");
	piano_ant = read_nurbs("piano_ant.db");
	base_ant = read_nurbs("base_anteriore.db");
	asse_orizz = read_nurbs("asse_orizz.db");
	asta = read_nurbs("asta.db");
	supporto = read_nurbs("supporto_asta.db");
	connettore = read_nurbs("connettore.db");
	set_attribute(connettore, rosso);
	connettore_tmp = create_copy(connettore, "connettore_tmp");
	// lista della parte inferiore
	lista_parte_inferiore = create_list(base, "parte_inferiore");
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, piano);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(r_blocco, "r_blocco_sx"));
	set_translate(r_blocco, 0.0, -2.95, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, r_blocco);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, piano_ant);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, base_ant);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, asse_orizz);
	// aste per le ruote
	asta_tmp = create_copy(asta, "asta_tmp");
	set_translate(asta, 1.25, 1.75, -1.6);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta, "asta1"));
	set_translate(asta, 0.0, -0.2, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta, "asta2"));
	set_translate(asta, -1.8, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta, "asta3"));
	set_translate(asta_tmp, 1.25, -1.75, -1.6);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta_tmp, "asta4"));
	set_translate(asta_tmp, 0.0, 0.2, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta_tmp, "asta5"));
	set_translate(asta_tmp, -1.8, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta_tmp, "asta6"));
	set_translate(supporto, 0.4, 1.6, -1.6);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(supporto, "supporto1"));
	set_translate(supporto, -1.8, -0.2, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(supporto, "supporto2"));
	set_translate(supporto, 0.0, -2.8, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(supporto, "supporto3"));
	set_translate(supporto, 1.8, -0.2, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(supporto, "supporto4"));
	// parti rosse
	set_attribute(lista_parte_inferiore, nero);
	set_translate(asta, 2.6, 0.2, 0.25);
	set_attribute(asta, rosso);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta, "asta_rosso1"));
	set_translate(asta, 0.0, -3.50, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(asta, "asta_rosso2"));
	set_scale(connettore, 1.4, 2.0, 2.5);
	set_z_rotate(connettore, 180, 1);
	set_translate(connettore, 0.9, 1.5, -0.9);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(connettore, "connettore1"));
	set_scale(connettore_tmp, 1.4, 2.0, 2.5);
	set_translate(connettore_tmp, 0.9, -1.5, -0.9);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(connettore_tmp, "connettore2"));

	// ruote varie
	ruota_piccola = read_nurbs("ruota_piccola_sx.db");
	set_attribute(ruota_piccola, rosso);
	ruota_piccola2 = read_nurbs("ruota_piccola_dx.db");
	set_attribute(ruota_piccola2, rosso);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(ruota_piccola, "ruota_piccola_psx"));
	set_translate(ruota_piccola, 8.6, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(ruota_piccola, "ruota_piccola_asx"));
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(ruota_piccola2, "ruota_piccola_adx"));
	set_translate(ruota_piccola2, -8.6, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(ruota_piccola2, "ruota_piccola_pdx"));
	set_scale(lista_ruota, 0.9, 0.9, 0.9);
	set_x_rotate(lista_ruota, -90, 1);
	set_translate(lista_ruota, 1.8, 1.35, -1.2);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(lista_ruota, "ruota_asx1"));
	set_translate(lista_ruota, -1.8, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(lista_ruota, "ruota_asx2"));
	set_translate(lista_ruota, -1.8, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(lista_ruota, "ruota_asx3"));
	set_scale(lista_ruota2, 0.9, 0.9, 0.9);
	set_x_rotate(lista_ruota2, 90, 1);
	set_translate(lista_ruota2, 1.8, -1.35, -1.2);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(lista_ruota2, "ruota_adx1"));
	set_translate(lista_ruota2, -1.8, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(lista_ruota2, "ruota_adx2"));
	set_translate(lista_ruota2, -1.8, 0.0, 0.0);
	lista_parte_inferiore = insert_in_list(lista_parte_inferiore, create_copy(lista_ruota2, "ruota_adx3"));

	//retro

	// oggetti scaletta
	montante = read_nurbs("montante_scaletta.db");
	piolo = read_nurbs("piolo_scaletta.db");
	// lista pioli
	lista_pioli = create_list(create_copy(piolo, "piolo1"), "lista_pioli");
	for (i = 2; i < 5; i++)
	{
		snprintf(nome, 9, "piolo%d", i);
		set_translate(piolo, 0.0, 0.0, -0.25);
		lista_pioli = insert_in_list(lista_pioli, create_copy(piolo, nome));
	}
	// lista scaletta posteriore
	lista_scaletta = create_list(create_copy(lista_pioli, "pioli"), "scaletta");
	lista_scaletta = insert_in_list(lista_scaletta, create_copy(montante, "montante1"));
	set_translate(montante, -0.7, 0.0, 0.0);
	lista_scaletta = insert_in_list(lista_scaletta, create_copy(montante, "montante2"));
	set_attribute(lista_scaletta, oro);

	// pareti
	// pareti laterali
	retro_v1 = read_nurbs("retro_vert1.db");
	retro_v2 = read_nurbs("retro_vert2.db");
	retro_v3 = read_nurbs("retro_vert3.db");
	retro_v4 = read_nurbs("retro_vert4.db");
	retro_o1 = read_nurbs("retro_orizz1.db");
	retro_o2 = read_nurbs("retro_orizz2.db");
	retro_inf = read_nurbs("retro_inf.db");
	set_translate(retro_inf, 2.8, -1.5, 0.0);
	set_scale(retro_inf, 0.8, 1.0, 1.95);
	set_z_rotate(retro_inf, 180, 1);
	set_projection_texture(retro_inf, nero, "textures/wearr.hr", 1, 1, 0.85, 0.85);
	retro_inf2 = create_copy(retro_inf, "retro_inf_dx");
	set_z_rotate(retro_inf, -180, 1);
	set_scale(retro_inf, 1.25, 1.0, 0.5);
	set_translate(retro_inf, -2.8, 1.5, 0.0);
	set_scale(retro_inf2, 1.25, 1.0, 0.5);
	set_translate(retro_inf2, -2.75, -1.5, 0.0);
	lista_lato_retro = create_list(retro_v1, "parete_retro");
	lista_lato_retro = insert_in_list(lista_lato_retro, retro_v2);
	lista_lato_retro = insert_in_list(lista_lato_retro, retro_v3);
	lista_lato_retro = insert_in_list(lista_lato_retro, retro_v4);
	lista_lato_retro = insert_in_list(lista_lato_retro, retro_o1);
	lista_lato_retro = insert_in_list(lista_lato_retro, retro_o2);

	// parte posteriore
	retro_ant = read_nurbs("retro_ant.dbe");
	tetto = read_nurbs("tetto.db");
	caldaia = read_nurbs("caldaia.db");
	coda = read_nurbs("coda.db");
	lista_retro = create_list(retro_ant, "retro");
	lista_retro = insert_in_list(lista_retro, tetto);
	lista_retro = insert_in_list(lista_retro, caldaia);
	lista_retro = insert_in_list(lista_retro, coda);
	lista_retro = insert_in_list(lista_retro, create_copy(lista_lato_retro, "parete_retro_sx"));
	set_translate(lista_lato_retro, 0.0, -3.2, 0.0);
	lista_retro = insert_in_list(lista_retro, create_copy(lista_lato_retro, "parete_retro_dx"));
	lista_retro = insert_in_list(lista_retro, create_copy(retro_inf, "retro_inf_sx"));
	lista_retro = insert_in_list(lista_retro, retro_inf2);
	set_attribute(lista_retro, nero);

	// lanterna
	lampada = read_nurbs("lampada.db");
	set_attribute(lampada, vetro);
	sostegno_lanterna = read_nurbs("sostegno_lanterna.db");
	set_attribute(sostegno_lanterna, nero);
	base_lanterna1 = read_nurbs("base_lanterna1.db");
	base_lanterna2 = read_nurbs("base_lanterna2.db");
	base_lanterna3 = read_nurbs("base_lanterna3.db");
	base_lanterna4 = read_nurbs("base_lanterna4.db");
	// lista lanterna
	lista_lanterna = create_list(base_lanterna1, "lanterna");
	lista_lanterna = insert_in_list(lista_lanterna, base_lanterna2);
	lista_lanterna = insert_in_list(lista_lanterna, base_lanterna3);
	lista_lanterna = insert_in_list(lista_lanterna, base_lanterna4);
	set_attribute(lista_lanterna, oro);
	lista_lanterna = insert_in_list(lista_lanterna, lampada);
	lista_lanterna = insert_in_list(lista_lanterna, sostegno_lanterna);

	// componenti vari

	// oggetti scala anteriore
	lato_scaletta = read_nurbs("lato_scaletta_ant.db");
	scalino = read_nurbs("scalino_ant.db");
	piano_scala = read_nurbs("piano_scala_ant.db");
	fondo_scala = read_nurbs("fondo_scala_ant.db");
	// lista scala anteriore
	lista_scala = create_list(create_copy(lato_scaletta, "lato_sx"), "scaletta_ant_dx");
	set_translate(lato_scaletta, 0.0, -0.3, 0.0);
	lista_scala = insert_in_list(lista_scala, create_copy(lato_scaletta, "lato_sx"));
	lista_scala = insert_in_list(lista_scala, create_copy(piano_scala, "piano_scala"));
	lista_scala = insert_in_list(lista_scala, create_copy(fondo_scala, "fondo_scala"));
	lista_scala = insert_in_list(lista_scala, create_copy(scalino, "scalino1"));
	for (i = 2; i < 5; i++)
	{
		snprintf(nome, 9, "scalino%d", i);
		set_translate(scalino, 0.23, 0.0, -0.28);
		lista_scala = insert_in_list(lista_scala, create_copy(scalino, nome));
	}
	set_attribute(lista_scala, oro);

	// altri componenti
	blocco1 = read_nurbs("blocco1.db");
	blocco2 = read_nurbs("blocco2.db");
	blocco3 = read_nurbs("blocco3.db");
	blocco4 = read_nurbs("blocco4.db");
	lista_blocco_oro = create_list(blocco1, "blocco_oro");
	lista_blocco_oro = insert_in_list(lista_blocco_oro, blocco2);
	lista_blocco_oro = insert_in_list(lista_blocco_oro, blocco3);
	lista_blocco_oro = insert_in_list(lista_blocco_oro, blocco4);
	set_attribute(lista_blocco_oro, oro);
	componente = read_nurbs("componente.db");
	set_attribute(componente, nero);

	// texture
	terreno = read_nurbs("terreno.db");
	set_domain_texture(terreno, nero, "textures/wood1.hr", 0.0, 1.0, 0.0, 1.0, 1, 0.7, 0.7);
	sfondo = create_copy(terreno, "sfondo");
	set_x_rotate(sfondo, 90, 1);
	set_y_rotate(sfondo, 60, 1);
	set_z_rotate(sfondo, -30, 1);
	set_translate(sfondo, -18.0, -30.0, 0.0);
	set_scale(sfondo, 1.3, 1.0, 1.0);
	sfondo2 = create_copy(terreno, "sfondo2");
	set_x_rotate(sfondo2, 90, 1);
	set_y_rotate(sfondo2, 60, 1);
	set_z_rotate(sfondo2, 60, 1);
	set_translate(sfondo2, 23.0, -30.0, 0.0);
	sfondo3 = create_copy(terreno, "sfondo3");
	set_x_rotate(sfondo3, 90, 1);
	set_y_rotate(sfondo3, 60, 1);
	set_z_rotate(sfondo3, 60, 1);
	set_translate(sfondo3, -25.0, 0.0, 0.0);

	// altro
	sfera = read_nurbs("sfera.db");
	set_attribute(sfera, vetro);
	sfera2 = create_copy(sfera, "sfera_piccola");
	sfera3 = create_copy(sfera, "sfera_interna");
	sfera4 = create_copy(sfera, "sfera_piccola2");
	sfera5 = create_copy(sfera, "sfera_piccola3");
	sfera6 = create_copy(sfera, "sfera_piccola4");
	set_scale(sfera, 3.0, 3.0, 3.0);
	set_scale(sfera3, 1.5, 1.5, 1.5);
	set_scale(sfera4, 0.5, 0.5, 0.5);
	set_scale(sfera5, 0.3, 0.3, 0.3);
	set_scale(sfera6, 0.8, 0.8, 0.8);
	set_translate(sfera, -4.0, -13.0, 1.0);
	set_translate(sfera2, -2.0, 5.0, -1.0);
	set_translate(sfera3, -4.0, -13.0, 1.0);
	set_translate(sfera4, 5.0, 4.5, -1.5);
	set_translate(sfera5, 5.0, 4.5, -1.5);
	set_translate(sfera6, -2.0, 5.0, -1.0);

	asse_r = read_nurbs("asse_ant_rosso.db");
	set_translate(asse_r, -0.05, 0.0, 0.05);
	mont_r = read_nurbs("mont_ant_rosso.db");
	spigolo_r = read_nurbs("spigolo_ant_rosso.db");
	set_x_rotate(spigolo_r, -10, 1);
	set_z_rotate(spigolo_r, 3.6, 1);
	set_scale(spigolo_r, 0.9, 1.05, 1.0);
	spigolo_r2 = create_copy(spigolo_r, "spigolo_rosso2");
	//set_z_rotate(spigolo_r2, 78, 1);
	set_x_rotate(spigolo_r2, 198, 1);
	set_translate(spigolo_r2, 0.05, 0.14, -1.3);
	set_translate(spigolo_r, 0.05, 0.08, 0.05);
	lista_resp = create_list(create_copy(mont_r, "mont_r0"), "lista_respingente");
	for (i = 1; i < 6; i++)
	{
		tmp_mont = create_copy(mont_r, "tmp_mont");
		snprintf(nome, 9, "mont_r%d", i);
		set_y_rotate(tmp_mont, -i*7, 1);
		set_scale(tmp_mont, 1.0+(0.19*i), 1.0, 1.0);
		set_translate(tmp_mont, i*0.07, -i*0.2, -0.01);
		lista_resp = insert_in_list(lista_resp, create_copy(tmp_mont, nome));
		if (i < 5)
		{
			snprintf(nome, 9, "mont_r%d", 10-i);
			set_translate(tmp_mont, 0.0, -2*(1.0-(i*0.2)), 0.0);
			lista_resp = insert_in_list(lista_resp, create_copy(tmp_mont, nome));
		}
	}
	set_translate(mont_r, 0.0, -2.0, 0.0);
	lista_resp = insert_in_list(lista_resp, create_copy(mont_r, "mont_r10"));
	lista_resp = insert_in_list(lista_resp, asse_r);
	lista_resp = insert_in_list(lista_resp, spigolo_r);
	lista_resp = insert_in_list(lista_resp, spigolo_r2);
	set_attribute(lista_resp, rosso);
	set_translate(lista_resp, 5.22, 0.0, -1.1);

	// lista scena
	scena = create_list(create_copy(lista_scaletta, "scaletta_sx"), "scena");
	set_translate(lista_scaletta, 0.0, -2.6, 0.0);
	scena = insert_in_list(scena, lista_scaletta);
	scena = insert_in_list(scena, centrale2);
	scena = insert_in_list(scena, centrale3);
	scena = insert_in_list(scena, create_copy(lista_tubi, "tubo_sx"));
	set_x_rotate(lista_tubi, 130, 1);
	scena = insert_in_list(scena, lista_tubi);
	scena = insert_in_list(scena, sostegno);
	scena = insert_in_list(scena, campana);
	scena = insert_in_list(scena, superiore1);
	scena = insert_in_list(scena, superiore2);
	scena = insert_in_list(scena, comignolo);
	scena = insert_in_list(scena, cilindro_ant);
	scena = insert_in_list(scena, anello);
	set_scale(lista_anteriore, 1.6, 1.6, 1.5);
	set_y_rotate(lista_anteriore, 90, 1);
	set_translate(lista_anteriore, 4.1, 0.0, 0.0);
	scena = insert_in_list(scena, lista_anteriore);
	scena = insert_in_list(scena, lista_lanterna);
	scena = insert_in_list(scena, lista_retro);
	scena = insert_in_list(scena, create_copy(lista_scala, "scaletta_ant_sx"));
	set_translate(lista_scala, 0.0, -2.76, 0.0);
	scena = insert_in_list(scena, lista_scala);
	scena = insert_in_list(scena, create_copy(lista_blocco_oro, "blocco_sx"));
	set_translate(lista_blocco_oro, 0.0, -3.58, 0.0);
	scena = insert_in_list(scena, lista_blocco_oro);
	scena = insert_in_list(scena, create_copy(componente, "componente_sx"));
	set_translate(componente, 0.0, -3.59, 0.0);
	scena = insert_in_list(scena, componente);
	scena = insert_in_list(scena, lista_parte_inferiore);
	scena = insert_in_list(scena, terreno);
	scena = insert_in_list(scena, sfondo);
	scena = insert_in_list(scena, sfondo2);
	scena = insert_in_list(scena, sfondo3);
	scena = insert_in_list(scena, sfera);
	scena = insert_in_list(scena, sfera2);
	scena = insert_in_list(scena, sfera3);
	scena = insert_in_list(scena, sfera4);
	scena = insert_in_list(scena, sfera5);
	scena = insert_in_list(scena, sfera6);
	scena = insert_in_list(scena, lista_resp);

	save_scene("locomotiva.md", "locomotiva", scena);

	return (0);
}
